diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet.test b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet.test
index 9d67ac16..04b3243b 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet.test
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet.test
@@ -21,6 +21,26 @@ class MediaInternetTestHelper extends DrupalWebTestCase {
     parent::setUp($modules);
   }
 
+  /**
+   * Retrieves a sample file of the specified type.
+   */
+  function getTestFile($type_name, $size = NULL) {
+    // Get a file to upload.
+    $file = current($this->drupalGetTestFiles($type_name, $size));
+
+    // Add a filesize property to files as would be read by file_load().
+    $file->filesize = filesize($file->uri);
+
+    return $file;
+  }
+
+  /**
+   * Retrieves the fid of the last inserted file.
+   */
+  function getLastFileId() {
+    return (int) db_query('SELECT MAX(fid) FROM {file_managed}')->fetchField();
+  }
+
   /**
    * Get a file from the database based on its filename.
    *
@@ -38,6 +58,21 @@ class MediaInternetTestHelper extends DrupalWebTestCase {
     $returned_file = reset($files);
     return $returned_file;
   }
+
+  protected function createFileType($overrides = array()) {
+    $type = new stdClass();
+    $type->type = 'test';
+    $type->label = "Test";
+    $type->description = '';
+    $type->mimetypes = array('image/jpeg', 'image/gif', 'image/png', 'image/tiff');
+
+    foreach ($overrides as $k => $v) {
+      $type->$k = $v;
+    }
+
+    file_type_save($type);
+    return $type;
+  }
 }
 
 /**
@@ -49,7 +84,6 @@ class MediaInternetBrowserWebTabTestCase extends MediaInternetTestHelper {
       'name' => 'Media browser web tab test',
       'description' => 'Tests the media browser web tab.',
       'group' => 'Media Internet',
-      'dependencies' => array('fake'), // @todo remove when File Entity > alpha3 is released. This test currently fails on drupal.org due to testbot dependency issues.
     );
   }
 
@@ -83,45 +117,44 @@ class MediaInternetBrowserWebTabTestCase extends MediaInternetTestHelper {
 }
 
 /**
- * Test file creation through the file upload wizard with remote media.
+ * Test the default MediaInternetFileHandler provider.
  */
-class MediaInternetCreationTestCase extends MediaInternetTestHelper {
+class MediaInternetRemoteFileTestCase extends MediaInternetTestHelper {
   public static function getInfo() {
     return array(
-      'name' => 'Remote media file creation',
-      'description' => 'Test file creation with remote media.',
+      'name' => 'Remote media file handler provider',
+      'description' => 'Test the default remote file handler provider.',
       'group' => 'Media Internet',
-      'dependencies' => array('fake'), // @todo remove when File Entity > alpha3 is released. This test currently fails on drupal.org due to testbot dependency issues.
     );
   }
 
   function setUp() {
     parent::setUp();
 
-    $web_user = $this->drupalCreateUser(array('create files', 'add media from remote sources', 'edit own document files'));
+    // Disable the private file system which is automatically enabled by
+    // DrupalTestCase so we can test the upload wizard correctly.
+    variable_del('file_private_path');
+
+    $web_user = $this->drupalCreateUser(array('create files', 'add media from remote sources'));
     $this->drupalLogin($web_user);
   }
 
   /**
-   * Tests file creation with remote media.
+   * Tests the default remote file handler.
    */
-  function testRemoteMediaFileCreation() {
-    // Create a file.
+  function testRemoteFileHandling() {
+    // Step 1: Add a basic document file by providing a URL to the file.
     $edit = array();
     $edit['embed_code'] = file_create_url('README.txt');
     $this->drupalPost('file/add/web', $edit, t('Next'));
 
-    // Step 2: Scheme selection
-    if ($this->xpath('//input[@name="scheme"]')) {
-      $this->drupalPost(NULL, array(), t('Next'));
-    }
-
-    // Check that the document file has been uploaded.
-    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document', '%name' => 'README.txt')), t('Document file uploaded.'));
-
     // Check that the file exists in the database.
-    $file = $this->getFileByFilename('README.txt');
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
     $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the video file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document', '%name' => $file->filename)), t('Document file uploaded.'));
   }
 }
 
@@ -134,43 +167,228 @@ class MediaInternetProviderTestCase extends MediaInternetTestHelper {
       'name' => 'Custom media provider test',
       'description' => 'Tests the custom media provider APIs.',
       'group' => 'Media Internet',
-      'dependencies' => array('fake'), // @todo remove when File Entity > alpha3 is released. This test currently fails on drupal.org due to testbot dependency issues.
     );
   }
 
   function setUp() {
     parent::setUp('media_internet_test');
 
-    $web_user = $this->drupalCreateUser(array('access media browser', 'create files', 'add media from remote sources', 'edit own video files'));
+    // Disable the private file system which is automatically enabled by
+    // DrupalTestCase so we can test the upload wizard correctly.
+    variable_del('file_private_path');
+
+    // Enable media_internet_test.module's hook_media_internet_providers()
+    // implementation.
+    variable_set('media_internet_test_media_internet_providers', TRUE);
+
+    $web_user = $this->drupalCreateUser(array('create files', 'view own private files', 'add media from remote sources'));
     $this->drupalLogin($web_user);
   }
 
   /**
-   * Tests file creation with a custom media provider.
+   * Test the basic file upload wizard functionality.
    */
-  function testFilesBrowserSort() {
+  function testMediaInternetCustomProviderWizardBasic() {
     $this->drupalGet('file/add/web');
     $this->assertResponse(200);
 
     // Check that the provider is listed as supported.
-    $supported_providers = 'Media Internet Test';
-    $this->assertRaw(t('Supported internet media providers: !providers.', array('!providers' => '<strong>' . $supported_providers . '</strong>')), t('The example media provider is enabled.'));
+    $this->assertRaw(t('Supported internet media providers: !providers.', array('!providers' => '<strong>' . 'Media Internet Test' . '</strong>')), t('The example media provider is enabled.'));
 
-    // Create a file.
+    // Enable media_internet_test.module's
+    // hook_media_browser_plugin_info_alter_alter() implementation and ensure it
+    // is working as designed.
+    variable_set('media_internet_test_media_internet_providers_alter', TRUE);
+
+    $this->drupalGet('file/add/web');
+    $this->assertRaw(t('Supported internet media providers: !providers.', array('!providers' => '<strong>' . 'Altered provider title' . '</strong>')), t('The example media provider was successfully altered.'));
+
+    // Step 1: Upload a basic video file.
     $edit = array();
     $edit['embed_code'] = 'http://www.example.com/video/123';
     $this->drupalPost('file/add/web', $edit, t('Next'));
 
-    // Step 2: Scheme selection
-    if ($this->xpath('//input[@name="scheme"]')) {
-      $this->drupalPost(NULL, array(), t('Next'));
-    }
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the video file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Video', '%name' => $file->filename)), t('Video file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard type step.
+   */
+  function testMediaInternetCustomProviderWizardTypes() {
+    // Create multiple file types with the same mime types.
+    $this->createFileType(array('type' => 'video1', 'label' => 'Video 1', 'mimetypes' => array('video/mediainternettest')));
+    $this->createFileType(array('type' => 'video2', 'label' => 'Video 2', 'mimetypes' => array('video/mediainternettest')));
+
+    // Step 1: Upload a basic video file.
+    $edit = array();
+    $edit['embed_code'] = 'http://www.example.com/video/123';
+    $this->drupalPost('file/add/web', $edit, t('Next'));
+
+    // Step 2: File type selection.
+    $edit = array();
+    $edit['type'] = 'video2';
+    $this->drupalPost(NULL, $edit, t('Next'));
+
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the video file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Video 2', '%name' => $file->filename)), t('Video 2 file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard scheme step.
+   */
+  function testMediaInternetCustomProviderWizardSchemes() {
+    // Enable the private file system.
+    variable_set('file_private_path', $this->private_files_directory);
+
+    // Step 1: Upload a basic video file.
+    $edit = array();
+    $edit['embed_code'] = 'http://www.example.com/video/123';
+    $this->drupalPost('file/add/web', $edit, t('Next'));
+
+    // Step 3: Users should not be able to select a scheme for files with
+    // read-only stream wrappers.
+    $this->assertNoFieldByName('scheme');
+
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
 
     // Check that the video file has been uploaded.
-    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Video', '%name' => 'Drupal')), t('Video file uploaded.'));
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Video', '%name' => $file->filename)), t('Video file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard field step.
+   */
+  function testMediaInternetCustomProviderWizardFields() {
+    $filename = $this->randomName();
+
+    // Add a text field to the video file type.
+    $field_name = drupal_strtolower($this->randomName() . '_field_name');
+    $field = array('field_name' => $field_name, 'type' => 'text');
+    field_create_field($field);
+    $instance = array(
+      'field_name' => $field_name,
+      'entity_type' => 'file',
+      'bundle' => 'video',
+      'label' => $this->randomName() . '_label',
+    );
+    field_create_instance($instance);
+
+    // Step 1: Upload a basic video file.
+    $edit = array();
+    $edit['embed_code'] = 'http://www.example.com/video/123';
+    $this->drupalPost('file/add/web', $edit, t('Next'));
+
+    // Step 4: Attached fields.
+    $edit = array();
+    $edit['filename'] = $filename;
+    $edit[$field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $this->randomName();
+    $this->drupalPost(NULL, $edit, t('Save'));
 
     // Check that the file exists in the database.
-    $file = $this->getFileByFilename('Drupal');
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
     $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the video file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Video', '%name' => $filename)), t('Video file uploaded.'));
+  }
+
+  /**
+   * Test skipping each of the file upload wizard steps.
+   */
+  function testMediaInternetCustomProviderWizardStepSkipping() {
+    $filename = $this->randomName();
+
+    // Ensure that the file is affected by every step.
+    variable_set('file_private_path', $this->private_files_directory);
+
+    $this->createFileType(array('type' => 'video1', 'label' => 'Video 1', 'mimetypes' => array('video/mediainternettest')));
+    $this->createFileType(array('type' => 'video2', 'label' => 'Video 2', 'mimetypes' => array('video/mediainternettest')));
+
+    $field_name = drupal_strtolower($this->randomName() . '_field_name');
+    $field = array('field_name' => $field_name, 'type' => 'text');
+    field_create_field($field);
+    $instance = array(
+      'field_name' => $field_name,
+      'entity_type' => 'file',
+      'bundle' => 'video2',
+      'label' => $this->randomName() . '_label',
+    );
+    field_create_instance($instance);
+
+    // Test skipping each upload wizard step.
+    foreach (array('types', 'schemes', 'fields') as $step) {
+      // Step to skip.
+      switch ($step) {
+        case 'types':
+          variable_set('file_entity_file_upload_wizard_skip_file_type', TRUE);
+          break;
+        case 'schemes':
+          variable_set('file_entity_file_upload_wizard_skip_scheme', TRUE);
+          break;
+        case 'fields':
+          variable_set('file_entity_file_upload_wizard_skip_fields', TRUE);
+          break;
+      }
+
+      // Step 1: Upload a basic video file.
+      $edit = array();
+      $edit['embed_code'] = 'http://www.example.com/video/123';
+      $this->drupalPost('file/add/web', $edit, t('Next'));
+
+      // Step 2: File type selection.
+      if ($step != 'types') {
+        $edit = array();
+        $edit['type'] = 'video2';
+        $this->drupalPost(NULL, $edit, t('Next'));
+      }
+
+      // Step 3: Users should not be able to select a scheme for files with
+      // read-only stream wrappers.
+      $this->assertNoFieldByName('scheme');
+
+      // Step 4: Attached fields.
+      if ($step != 'fields') {
+        // Skipping file type selection essentially skips this step as well
+        // because the file will not be assigned a type so no fields will be
+        // available.
+        if ($step != 'types') {
+          $edit = array();
+          $edit['filename'] = $filename;
+          $edit[$field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $this->randomName();
+          $this->drupalPost(NULL, $edit, t('Save'));
+        }
+      }
+
+      // Check that the file exists in the database.
+      $fid = $this->getLastFileId();
+      $file = file_load($fid);
+      $this->assertTrue($file, t('File found in database.'));
+
+      // Determine the file's file type.
+      $type = file_type_load($file->type);
+
+      // Check that the video file has been uploaded.
+      $this->assertRaw(t('!type %name was uploaded.', array('!type' => $type->label, '%name' => $file->filename)), t('Video file uploaded.'));
+
+      // Reset 'skip' variables.
+      variable_del('file_entity_file_upload_wizard_skip_file_type');
+      variable_del('file_entity_file_upload_wizard_skip_scheme');
+      variable_del('file_entity_file_upload_wizard_skip_fields');
+    }
   }
 }
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info
index 193115db..09f831c4 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.info
@@ -7,9 +7,9 @@ hidden = TRUE
 files[] = includes/MediaInternetTestStreamWrapper.inc
 files[] = includes/MediaInternetTestHandler.inc
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module
index ee1279aa..cfcd69a2 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module
+++ b/drupal7/sites/all/modules/media/modules/media_internet/tests/media_internet_test.module
@@ -9,6 +9,11 @@
  * Implements hook_media_internet_providers().
  */
 function media_internet_test_media_internet_providers() {
+  // Allow tests to enable or disable this hook.
+  if (!variable_get('media_internet_test_media_internet_providers', FALSE)) {
+    return array();
+  }
+
   return array(
     'MediaInternetTestHandler' => array(
       'title' => t('Media Internet Test'),
@@ -16,6 +21,18 @@ function media_internet_test_media_internet_providers() {
   );
 }
 
+/**
+ * Implements hook_media_browser_plugin_info_alter_alter().
+ */
+function media_internet_test_media_internet_providers_alter(&$providers) {
+  // Allow tests to enable or disable this hook.
+  if (!variable_get('media_internet_test_media_internet_providers_alter', FALSE)) {
+    return;
+  }
+
+  $providers['MediaInternetTestHandler']['title'] = t('Altered provider title');
+}
+
 /**
  * Implements hook_stream_wrappers().
  */
diff --git a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc
index e88bda13..78131e88 100644
--- a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc
+++ b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/includes/media_migrate_file_types.pages.inc
@@ -150,18 +150,22 @@ function media_migrate_file_types_upgrade_file_types_confirm_submit($form, &$for
         $fields_to_move = array_diff($old_fields, $new_fields);
         $fields_to_drop = array_diff($old_fields, $fields_to_move);
 
-        db_update('field_config_instance')
-          ->fields(array('bundle' => $bundle_new->type))
-          ->condition('entity_type',  'file')
-          ->condition('bundle', $bundle_old->type)
-          ->condition('field_name', $fields_to_move, 'IN')
-          ->execute();
-
-        db_delete('field_config_instance')
-          ->condition('entity_type',  'file')
-          ->condition('bundle', $bundle_old->type)
-          ->condition('field_name', $fields_to_drop, 'IN')
-          ->execute();
+        if (!empty($fields_to_move)) {
+          db_update('field_config_instance')
+            ->fields(array('bundle' => $bundle_new->type))
+            ->condition('entity_type',  'file')
+            ->condition('bundle', $bundle_old->type)
+            ->condition('field_name', $fields_to_move, 'IN')
+            ->execute();
+        }
+
+        if (!empty($fields_to_drop)) {
+          db_delete('field_config_instance')
+            ->condition('entity_type',  'file')
+            ->condition('bundle', $bundle_old->type)
+            ->condition('field_name', $fields_to_drop, 'IN')
+            ->execute();
+        }
 
         field_cache_clear();
         module_invoke_all('field_attach_rename_bundle', 'file', $bundle_old->type, $bundle_new->type);
diff --git a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info
index 0031d93f..b872ec51 100644
--- a/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info
+++ b/drupal7/sites/all/modules/media/modules/media_migrate_file_types/media_migrate_file_types.info
@@ -8,9 +8,9 @@ dependencies[] = media
 
 configure = admin/structure/file-types/upgrade
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.filter.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.filter.inc
index 44360b3d..73d6b5ff 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.filter.inc
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.filter.inc
@@ -56,6 +56,7 @@ function media_wysiwyg_parse_css_declarations($declarations) {
  * @see hook_media_wysiwyg_token_to_markup_alter()
  */
 function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
+  static $recursion_stop;
   $settings = array();
   $match = str_replace("[[", "", $match);
   $match = str_replace("]]", "", $match);
@@ -107,6 +108,13 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
     if (!$file) {
       throw new Exception('Could not load media object');
     }
+    // Check if we've got a recursion. Happens because a file_load() may
+    // triggers file_entity_is_page() which then again triggers a file load.
+    if (isset($recursion_stop[$file->fid])) {
+      return '';
+    }
+    $recursion_stop[$file->fid] = TRUE;
+
     $tag_info['file'] = $file;
 
     // The class attributes is a string, but drupal requires it to be
@@ -117,6 +125,9 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
 
     // Grab the potentially overrided fields from the file.
     $fields = media_wysiwyg_filter_field_parser($tag_info);
+    foreach ($fields as $key => $value) {
+      $file->{$key} = $value;
+    }
 
     $attributes = is_array($tag_info['attributes']) ? $tag_info['attributes'] : array();
     $attribute_whitelist = variable_get('media_wysiwyg_wysiwyg_allowed_attributes', _media_wysiwyg_wysiwyg_allowed_attributes_default());
@@ -165,7 +176,7 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
 
   if ($wysiwyg) {
     $settings['wysiwyg'] = $wysiwyg;
-    // If sending markup to a WYSIWYG, we need to pass the file infomation so
+    // If sending markup to a WYSIWYG, we need to pass the file information so
     // that an inline macro can be generated when the WYSIWYG is detached.
     // The WYSIWYG plugin is expecting this information in the
     // Drupal.settings.mediaDataMap variable.
@@ -178,11 +189,16 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
     );
     drupal_add_js(array('mediaDataMap' => array($file->fid => $data)), 'setting');
     $element['#attributes']['data-fid'] = $file->fid;
+    $element['#attributes']['data-media-element'] = '1';
     $element['#attributes']['class'][] = 'media-element';
   }
   else {
     // Display the field elements.
     $element = array();
+    // Render the file entity, for sites using the file_entity rendering method.
+    if (variable_get('media_wysiwyg_default_render', 'file_entity') == 'file_entity') {
+      $element['content'] = file_view($file, $tag_info['view_mode']);
+    }
     $element['content']['file'] = media_wysiwyg_get_file_without_label($file, $tag_info['view_mode'], $settings);
     // Overwrite or set the file #alt attribute if it has been set in this
     // instance.
@@ -194,9 +210,12 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
     if (!empty($element['content']['file']['#attributes']['title'])) {
       $element['content']['file']['#title'] = $element['content']['file']['#attributes']['title'];
     }
-    field_attach_prepare_view('file', array($file->fid => $file), $tag_info['view_mode']);
-    entity_prepare_view('file', array($file->fid => $file));
-    $element['content'] += field_attach_view('file', $file, $tag_info['view_mode']);
+    // For sites using the legacy field_attach rendering method, attach fields.
+    if (variable_get('media_wysiwyg_default_render', 'file_entity') == 'field_attach') {
+      field_attach_prepare_view('file', array($file->fid => $file), $tag_info['view_mode']);
+      entity_prepare_view('file', array($file->fid => $file));
+      $element['content'] += field_attach_view('file', $file, $tag_info['view_mode']);
+    }
     if (count(element_children($element['content'])) > 1) {
       // Add surrounding divs to group them together.
       // We dont want divs when there are no additional fields to allow files
@@ -208,9 +227,17 @@ function media_wysiwyg_token_to_markup($match, $wysiwyg = FALSE) {
         'media-' . $element['content']['file']['#view_mode']
       );
     }
+
+    // Conditionally add a pre-render if the media filter output is be cached.
+    $filters = filter_get_filters();
+    if (!isset($filters['media_filter']['cache']) || $filters['media_filter']['cache']) {
+      $element['#pre_render'][] = 'media_wysiwyg_pre_render_cached_filter';
+    }
   }
   drupal_alter('media_wysiwyg_token_to_markup', $element, $tag_info, $settings);
-  return drupal_render($element);
+  $output = drupal_render($element);
+  unset($recursion_stop[$file->fid]);
+  return $output;
 }
 
 /**
@@ -241,33 +268,6 @@ function media_wysiwyg_filter_field_parser($tag_info) {
   return $fields;
 }
 
-/**
- * Builds a map of media tags in the element.
- *
- * Builds a map of the media tags in an element that are being rendered to their
- * rendered HTML. The map is stored in JS, so we can transform them when the
- * editor is being displayed.
- */
-function media_wysiwyg_pre_render_text_format($element) {
-  // filter_process_format() copies properties to the expanded 'value' child
-  // element.
-  if (!isset($element['format'])) {
-    return $element;
-  }
-
-  $field = &$element['value'];
-  $settings = array(
-    'field' => $field['#id'],
-  );
-
-  $tagmap = _media_wysiwyg_generate_tagMap($field['#value']);
-
-  if (isset($tagmap)) {
-    drupal_add_js(array('tagmap' => $tagmap), 'setting');
-  }
-  return $element;
-}
-
 /**
  * Creates map of inline media tags.
  *
@@ -357,3 +357,16 @@ function media_wysiwyg_get_wysiwyg_allowed_view_modes($file) {
   drupal_alter('media_wysiwyg_wysiwyg_allowed_view_modes', $view_modes, $file);
   return $view_modes;
 }
+
+/**
+ * #pre_render callback: Modify the element if the render cache is filtered.
+ */
+function media_wysiwyg_pre_render_cached_filter($element) {
+  // Remove contextual links since they are not compatible with cached filtered
+  // text.
+  if (isset($element['content']['#contextual_links'])) {
+    unset($element['content']['#contextual_links']);
+  }
+
+  return $element;
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.pages.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.pages.inc
index ab1a845d..72653b8f 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.pages.inc
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/includes/media_wysiwyg.pages.inc
@@ -83,7 +83,7 @@ function media_wysiwyg_format_form($form, &$form_state, $file) {
       they are inserted into an editor.')
   );
 
-  // Add fields from the file, so that we can override them if neccesary.
+  // Add fields from the file, so that we can override them if necessary.
   $form['options']['fields'] = array();
   foreach ($fields as $field_name => $field_value) {
     $file->{$field_name} = $field_value;
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.filter.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.filter.js
index 5ac10ec4..efccd59c 100644
--- a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.filter.js
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.filter.js
@@ -46,6 +46,7 @@
             var source = Drupal.settings.mediaSourceMap[media_definition.fid];
             media = document.createElement(source.tagName);
             media.src = source.src;
+            media.innerHTML = source.innerHTML;
           }
 
           // Apply attributes.
@@ -72,25 +73,39 @@
       // Rewrite the tagmap in case any of the macros have changed.
       Drupal.settings.tagmap = {};
 
-      // Wrap the content to be able to use replaceWith() and html().
-      content = $('<div>').append(content);
-      var media = $('.media-element', content);
-
-      if (media.length) {
-        // Replace all media elements with their respective macros.
-        media.replaceWith(function() {
-          var el = $(this),
-            macro = Drupal.media.filter.create_macro(el);
-
-          // Store the markup for more efficient rendering later.
-          // @see replaceTokenWidthPlaceholder()
-          Drupal.settings.tagmap[macro] = Drupal.media.filter.outerHTML(el);
-
-          return macro;
-        });
+      // Replace all media placeholders with their JSON macro representations.
+      //
+      // There are issues with using jQuery to parse the WYSIWYG content (see
+      // http://drupal.org/node/1280758), and parsing HTML with regular
+      // expressions is a terrible idea (see http://stackoverflow.com/a/1732454/854985)
+      //
+      // WYSIWYG editors act wacky with complex placeholder markup anyway, so an
+      // image is the most reliable and most usable anyway: images can be moved by
+      // dragging and dropping, and can be resized using interactive handles.
+      //
+      // Media requests a WYSIWYG place holder rendering of the file by passing
+      // the wysiwyg => 1 flag in the settings array when calling
+      // media_get_file_without_label().
+      //
+      // Finds the media-element class.
+      var classRegex = 'class=[\'"][^\'"]*?media-element';
+      // Image tag with the media-element class.
+      var regex = '<img[^>]+' + classRegex + '[^>]*?>';
+      // Or a span with the media-element class (used for documents).
+      // \S\s catches any character, including a linebreak; JavaScript does not
+      // have a dotall flag.
+      regex += '|<span[^>]+' + classRegex + '[^>]*?>[\\S\\s]+?</span>';
+      var matches = content.match(RegExp(regex, 'gi'));
+      if (matches) {
+        for (i = 0; i < matches.length; i++) {
+          markup = matches[i];
+          macro = Drupal.media.filter.create_macro($(markup));
+          Drupal.settings.tagmap[macro] = markup;
+          content = content.replace(markup, macro);
+        }
       }
 
-      return content.html();
+      return content;
     },
 
     /**
@@ -129,7 +144,8 @@
         Drupal.media.filter.ensureSourceMap();
         Drupal.settings.mediaSourceMap[info.fid] = {
           tagName: element[0].tagName,
-          src: element[0].src
+          src: element[0].src,
+          innerHTML: element[0].innerHTML
         }
       }
 
@@ -142,14 +158,20 @@
       // Store the fid in the DOM to retrieve the data from the info map.
       element.attr('data-fid', info.fid);
 
-      // Add media-element class so we can find markup element later.
-      var classes = ['media-element'];
+      // Add data-media-element attribute so we can find the markup element later.
+      element.attr('data-media-element', '1')
 
+      var classes = ['media-element'];
       if (info.view_mode) {
         classes.push('file-' + info.view_mode.replace(/_/g, '-'));
       }
       element.addClass(classes.join(' '));
 
+      // Apply link_text if present.
+      if (info.link_text) {
+        $('a', element).html(info.link_text);
+      }
+
       return element;
     },
 
@@ -162,6 +184,10 @@
     create_macro: function (element) {
       var file_info = Drupal.media.filter.extract_file_info(element);
       if (file_info) {
+        if (typeof file_info.link_text == 'string') {
+          // Make sure the link_text-html-tags are properly escaped.
+          file_info.link_text = file_info.link_text.replace(/</g, '&lt;').replace(/>/g, '&gt;');
+        }
         return '[[' + JSON.stringify(file_info) + ']]';
       }
       return false;
